package Enemies;

abstract class EnemyConverter
{
    public final String itemType = "Enemy";
    public abstract String getEnemyName();
    public abstract int getEnemyAttack();
    public abstract void setEnemyAttack(int enemyAttack);
    public abstract int getEnemyHealth();
    public abstract void setEnemyHealth(int enemyHealth); 
    public abstract String getEnemyStats();
    
    public final String[][] normalEnemies = new String[][]{{"Zombie","13","50"},
                                                           {"Skeleton","12","50"},
                                                           {"Spider","11","50"},
                                                           {"Creeper","11","50"},
                                                           {"Wolf","9","50"},
                                                           {"Ogre","15","100"}};

     public final String[][] bossEnemies = new String[][]{{"Dragon","26","100"},
                                                          {"Evil Bunny","22","100"},
                                                          {"Demon","40","100"}};   
}

