package StartUp;

import Hero.Hero;
import Menus.Explore;

import Tools.FileManagement;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

public class MainMenu extends javax.swing.JFrame 
{
    public MainMenu() 
    {     
         initComponents(); 
         this.setVisible(true);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainMenuPane = new javax.swing.JLayeredPane();
        titleLabel = new javax.swing.JLabel();
        newGameButton = new javax.swing.JButton();
        loadGameButton = new javax.swing.JButton();
        aboutButton = new javax.swing.JButton();
        exitButton = new javax.swing.JButton();
        background = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        mainMenuPane.setMaximumSize(new java.awt.Dimension(561, 331));
        mainMenuPane.setMinimumSize(new java.awt.Dimension(561, 331));

        titleLabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        titleLabel.setText("Legend of the Secret");
        titleLabel.setToolTipText("");

        newGameButton.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        newGameButton.setForeground(new java.awt.Color(255, 255, 255));
        newGameButton.setText("New Game");
        newGameButton.setAutoscrolls(true);
        newGameButton.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(240, 240, 240)));
        newGameButton.setBorderPainted(false);
        newGameButton.setContentAreaFilled(false);
        newGameButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        newGameButton.setFocusPainted(false);
        newGameButton.setFocusable(false);
        newGameButton.setRequestFocusEnabled(false);
        newGameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newGameButtonActionPerformed(evt);
            }
        });

        loadGameButton.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        loadGameButton.setForeground(new java.awt.Color(255, 255, 255));
        loadGameButton.setText("Load Game");
        loadGameButton.setAutoscrolls(true);
        loadGameButton.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(240, 240, 240)));
        loadGameButton.setBorderPainted(false);
        loadGameButton.setContentAreaFilled(false);
        loadGameButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        loadGameButton.setFocusable(false);
        loadGameButton.setRequestFocusEnabled(false);
        loadGameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadGameButtonActionPerformed(evt);
            }
        });

        aboutButton.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        aboutButton.setForeground(new java.awt.Color(255, 255, 255));
        aboutButton.setText("About");
        aboutButton.setAutoscrolls(true);
        aboutButton.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(240, 240, 240)));
        aboutButton.setBorderPainted(false);
        aboutButton.setContentAreaFilled(false);
        aboutButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        aboutButton.setFocusable(false);
        aboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutButtonActionPerformed(evt);
            }
        });

        exitButton.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        exitButton.setForeground(new java.awt.Color(255, 255, 255));
        exitButton.setText("Exit");
        exitButton.setAutoscrolls(true);
        exitButton.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(240, 240, 240)));
        exitButton.setBorderPainted(false);
        exitButton.setContentAreaFilled(false);
        exitButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        exitButton.setFocusable(false);
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        background.setIcon(new javax.swing.ImageIcon(getClass().getResource("/StartUp/battle.png"))); // NOI18N

        javax.swing.GroupLayout mainMenuPaneLayout = new javax.swing.GroupLayout(mainMenuPane);
        mainMenuPane.setLayout(mainMenuPaneLayout);
        mainMenuPaneLayout.setHorizontalGroup(
            mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(background, javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(newGameButton, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(440, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addGap(333, 333, 333)
                    .addComponent(titleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(32, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addGap(20, 20, 20)
                    .addComponent(loadGameButton)
                    .addContainerGap(450, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(aboutButton, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(451, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(exitButton, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(456, Short.MAX_VALUE)))
        );
        mainMenuPaneLayout.setVerticalGroup(
            mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(background, javax.swing.GroupLayout.DEFAULT_SIZE, 342, Short.MAX_VALUE)
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainMenuPaneLayout.createSequentialGroup()
                    .addContainerGap(175, Short.MAX_VALUE)
                    .addComponent(newGameButton)
                    .addGap(132, 132, 132)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addGap(27, 27, 27)
                    .addComponent(titleLabel)
                    .addContainerGap(282, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addGap(223, 223, 223)
                    .addComponent(loadGameButton)
                    .addContainerGap(83, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(mainMenuPaneLayout.createSequentialGroup()
                    .addGap(255, 255, 255)
                    .addComponent(aboutButton)
                    .addContainerGap(51, Short.MAX_VALUE)))
            .addGroup(mainMenuPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainMenuPaneLayout.createSequentialGroup()
                    .addContainerGap(273, Short.MAX_VALUE)
                    .addComponent(exitButton)
                    .addGap(33, 33, 33)))
        );
        mainMenuPane.setLayer(titleLabel, javax.swing.JLayeredPane.DEFAULT_LAYER);
        mainMenuPane.setLayer(newGameButton, javax.swing.JLayeredPane.DEFAULT_LAYER);
        mainMenuPane.setLayer(loadGameButton, javax.swing.JLayeredPane.DEFAULT_LAYER);
        mainMenuPane.setLayer(aboutButton, javax.swing.JLayeredPane.DEFAULT_LAYER);
        mainMenuPane.setLayer(exitButton, javax.swing.JLayeredPane.DEFAULT_LAYER);
        mainMenuPane.setLayer(background, javax.swing.JLayeredPane.DEFAULT_LAYER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainMenuPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainMenuPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        mainMenuPane.getAccessibleContext().setAccessibleName("");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void newGameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newGameButtonActionPerformed
        MainMenu.this.dispose();
        NewGame ng = new NewGame();
        ng.setLocationRelativeTo(null);
        ng.setVisible(true);
        //Test t = new Test();
        

    }//GEN-LAST:event_newGameButtonActionPerformed

    private void loadGameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadGameButtonActionPerformed
        try
        {
            JFileChooser loadF = new JFileChooser();
            File temp = new File("");
            String dir = temp.getAbsolutePath();
            loadF.setCurrentDirectory(new File(dir));
            FileFilter serFilter = new FileNameExtensionFilter("Hero Files", "ser");
            loadF.setFileFilter(serFilter);
            loadF.showOpenDialog(null);
            File f = loadF.getSelectedFile();
            FileManagement fm = new FileManagement();
            Hero h = fm.loadFile(f); 
            if (h != null)
            {
                MainMenu.this.dispose();
                Explore eg = new Explore(h);
                eg.setLocationRelativeTo(null);
                eg.setVisible(true);
            }
        }
        catch(NullPointerException npe)
       {
           
       }
    }//GEN-LAST:event_loadGameButtonActionPerformed

    private void aboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutButtonActionPerformed
       JOptionPane.showMessageDialog(null,"Thanks for trying my game. \nIf you have any comments, suggestions, or questions email me at davidsrpg@gmail.com."
               + "\nAlpha Version 5.1"
               + "\nHero Character Graphics By: Veni Mortem "
               + "\nSite: http://veni-mortem.deviantart.com/");
    }//GEN-LAST:event_aboutButtonActionPerformed

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitButtonActionPerformed

    public static void main(String args[]) 
    {
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainMenu.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainMenu.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainMenu.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainMenu.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        java.awt.EventQueue.invokeLater(new Runnable() 
        {
            public void run() 
            {
                new MainMenu().setLocationRelativeTo(null);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aboutButton;
    private javax.swing.JLabel background;
    private javax.swing.JButton exitButton;
    private javax.swing.JButton loadGameButton;
    private javax.swing.JLayeredPane mainMenuPane;
    private javax.swing.JButton newGameButton;
    private javax.swing.JLabel titleLabel;
    // End of variables declaration//GEN-END:variables
}
