import java.io.Serializable;
import java.io.*;
import java.util.*;

public class Inventory implements Serializable
{	
	public Inventory(Hero h)
	{
		invMainMenu(h);
	}
	
	public static void invMainMenu(Hero h)
	{
		lb();
		String invmenu;
		String invsubmenu;
		int error = 0;
		Scanner input = new Scanner (System.in);
		
		do
		{
			System.out.println("\n\n\n\n\n\n\n\n\n\n\n");
			System.out.println("This option is an Beta v3 build.");
			System.out.println("Please select what you would like to do: ");
			System.out.println("------WEAPONS------");
			System.out.println("1. View Weapon Inventory");
			System.out.println("2. Switch your current weapon.");
			System.out.println("3. Remove a weapon from the inventory.");
			System.out.println("4. Attempt to repair your current weapon (CHANCE TO REDUCE WEAPON HEALTH)");
			System.out.println("------ITEMS------");
			System.out.println("5. View Item Inventory.");
			System.out.println("6. Use an item in your inventory.");
			System.out.println("7. Remove an item from the inventory.");
			System.out.println("8. Check the full stats for a single item in your inventory. --DEBUG INFO--");
			System.out.println("20. **TESTING ONLY** Add random weapon to inventory.");
			System.out.println("21. **TESTING ONLY** Add random item to inventory.");
			System.out.println("22. **TESTING ONLY** View raw item data.");
			System.out.println("0. Return to previous menu.");
			invmenu = input.next();
			if(isInt(invmenu) == true)
			{
				switch(Integer.parseInt(invmenu))
				{
					case 1:
					{
						lb();
						h.getInventory();
						System.out.println("\n\n");
						pauseProg();
						break;
					}
					case 2:
					{
						lb();
						h.getInventory();
						System.out.println("\nPlease enter the number of the weapon that you want to switch out: ");
						invsubmenu = input.next();
						if (h.getInvSizeA() >= Integer.parseInt(invsubmenu))
						{
							h.switchWeapon(Integer.parseInt(invsubmenu));
						}
						else
						{
							System.out.println("Please make a valid choice.");
						}
						pauseProg();
						break;
					}
					case 3:
					{
						lb();
						h.getInventory();
						System.out.println("\nPlease enter the number of the weapon that you want to remove:");
						invsubmenu = input.next();
						h.destroyWeapon(Integer.parseInt(invsubmenu));
						pauseProg();
						break;
					}
					case 4:
					{
						lb();
						String ws1 = h.weaponToString(h.getWeaponObject()); 
						h.repairWeapon(); 
						h.removeWeapon(ws1); 
						if (!h.getWeaponStats().equals(0))
						{
							h.addWeaponToInv(h.weaponToString(h.getWeaponObject())); 
						}
						pauseProg();
						break;
					}
					case 5:
					{
						lb();
						h.getItemInventory();
						pauseProg();
						break;
					}
					case 6:
					{
						lb();
						h.getItemInventory();
						System.out.println("\nPlease enter the number of the item that you want to use: ");
						invsubmenu = input.next();
						int itemnum = Integer.parseInt(invsubmenu) + 1;
						String iCode = h.getItem(itemnum);
						Item eItem = new Item(iCode);
						String effectPassed = eItem.getPassEffect();
						/*if(isInt(effectPassed))
						{
							double eNum = Integer.parseInt(effectPassed);
							System.out.println("Number passed " + eNum);
						}*/
						
						{
							System.out.println(effectPassed);
							//if (effectPassed.equals("TRUE"))
							{
								String eCat = eItem.getCategory();
								String eName = eItem.getName();
								switch(eCat)
								{
									case "Anti-status":
									{
										if(effectPassed.equals("TRUE"))
										{
											if(eName.equals(h.getStatus()))
											{
												h.setStatus("Normal");
												
												h.destroyItem(itemnum);
											}
											else
											{
												System.out.println("This item has no effect.");
												h.destroyItem(itemnum);
											}
										}
										else
										{
											System.out.println("Item failed");
											h.destroyItem(itemnum);
										}
										break;
									}
									case "Point Enhancers":
									{
										if(eName.equals("Potion"))
										{
											int health1 = h.getHealth();
											int health2 = Integer.parseInt(effectPassed);
											int healthtotal = health1 + health2;
											h.setHealth(healthtotal);
											System.out.println(health1);
											System.out.println(health2);
											System.out.println(healthtotal);
											h.destroyItem(itemnum);
											break;
										}
									}
									case "NULL":
									{
										break;
									}
											
								}
							}
						}
						
						pauseProg();
						break;
					}
					case 7:
					{
						lb();
						h.getItemInventory();
						System.out.println("\nPlease enter the number of the item that you want to remove: ");
						invsubmenu = input.next();
						h.destroyItem(Integer.parseInt(invsubmenu));
						pauseProg();
						break;
					}
						
					case 8:
					{
						lb();
						h.getItemInventory();
						System.out.println("\nPlease enter the number of the item that you want to check the stats on:");
						invsubmenu = input.next();
						int invnum = Integer.parseInt(invsubmenu);
						String iCode = h.getItem(invnum);
						Item eItem = new Item(iCode);
						pauseProg();
						break;
					}	
					case 20:
					{
						Weapon nrw = new Weapon();
						String nws = h.weaponToString(nrw);
						
						h.addWeaponToInv(nws);
						
						break;
					}
					case 21:
					{
						Item ni = new Item();
						String its = ni.itemToString(ni.getItemName(), ni.getEffect(), ni.getIC());
						h.addItemToInv(its);
						break;
					}
					case 22:
					{
						h.getRawInv();
						break;
					}
				}
			}
		}
		while(!invmenu.equals("0"));
	}
	
	public static void pauseProg()
	{
		System.out.println("Press enter to continue...");
		Scanner keyboard = new Scanner(System.in);
		keyboard.nextLine();
		lb();
	}
	public static void lb()
	{
		System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}