import java.io.Serializable;
import java.text.*;
import javax.swing.JOptionPane;

public final class Hero implements Serializable
{
	private String name; //default values
	private int health; // 300
	private int attack; // 10
	private int defense; // 10
	private int exp; // 0 
	private String status; //Normal (Poison,Burn,Paralyze,Sleeping,Confusion)
	private double money; //$0.00
	Weapon w1 = new Weapon();
	private final DecimalFormat Currency = new DecimalFormat("$0.00");	
	
	private String weaponName; //Weapon Name
	private int weaponAttack; //Weapon Attack Stats
	private int weaponStat; //Weapon Health
	private int weaponSpeed; //Weapon Speed
        private double weaponValue;
	private int inventorySizeA = 21; //21 weapons
	private String inventoryA[] = new String[inventorySizeA]; //Weapon Inventory
	private int inventorySizeB = 20; //20 items
	private String inventoryB[] = new String[inventorySizeB];  //Item Inventory
        private int inventorySizeC = 15;//store weapons 15 items
        private String inventoryC[] = new String[inventorySizeC]; //Store Weapon Inventory
        private int inventorySizeD = 15;//store items 15 items
        private String inventoryD[] = new String[inventorySizeD];
	private int totalatk;
	
	public Hero()
	{
		setName("");
		setHealth(300);
		doWeapon();
		setDefense(10);
		setExp(0);
		totalatk = 10 + weaponAttack;
		setAttack(10);
		setStatus("Normal");
		setMoney(0.00);
		setAttackWeapon(totalatk);
		addWeaponToInv(weaponToString(w1));
	}
	
	public void addWeaponToInv(String ws1)
	{
            for(int i = 0; i<inventoryA.length; i++)
            {
                if(inventoryA[i] == null)
                {
                    
                    if(exp < 500)//Level 1
                    {
                        for(int lvl1 = 0; lvl1<=5; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 5;
                                for (lvl1 = 6; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                    if(exp > 501 && exp < 2500)//Level 2
                    {
                        for(int lvl1 = 0; lvl1<=6; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 6;
                                for (lvl1 = 7; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                    if(exp > 2501 && exp < 4500)//Level 3
                    {
                        for(int lvl1 = 0; lvl1<=7; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 7;
                                for (lvl1 = 8; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                    if(exp > 4501 && exp < 8000)//Level 4
                    {
                        for(int lvl1 = 0; lvl1<=8; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 8;
                                for (lvl1 = 9; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                    if(exp > 8001 && exp < 15500)//Level 5
                    {
                        for(int lvl1 = 0; lvl1<=9; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 9;
                                for (lvl1 = 10; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                    if(exp > 15501 && exp < 27000)//Level 6
                    {
                        for(int lvl1 = 0; lvl1<=10; lvl1++)
                        {
                            if(inventoryA[lvl1] == null)
                            {
                                inventoryA[lvl1] = ws1;			
                                lvl1 = 10;
                                for (lvl1 = 11; lvl1<inventoryA.length; lvl1++)
                                {
                                    inventoryA[lvl1] = "Locked";
                                }   
                                
                                i = inventoryA.length;
                            }
                        }    
                    }
                }
            }
	}
	
	public void addItemToInv(String it1)
	{
		for(int i = 0; i<inventoryB.length; i++)
		{
			if(inventoryB[i] == null)
			{
				inventoryB[i] = it1;
				i = inventoryB.length;
			}
		}
	}
        
        public void doWeaponStore()
        {
            String wts;
            double price;
            for(int i = 0; i<inventoryC.length; i++)
            {
                inventoryC[i] = null;
                Weapon w = new Weapon();
                price = w.getValue();
                price = price + 5 + (price * .65);
                w.setValue(price);
                wts = weaponToString(w);
                
                inventoryC[i] = wts;
                
            }
        }
        
        public void doItemStore()
        {
            String its;
            double price;
            for(int i = 0; i<inventoryD.length; i++)
            {
                inventoryD[i] = null;
                Item w = new Item();
                price = w.getValue();
                price = price + 5 + (price * .65);
                w.setValue(price);
                its = w.itemToString(w.getItemName(),w.getEffect(),w.getIC(),Double.toString(w.getValue()));
                
                inventoryD[i] = its;
                
            }
        }
        public String buyWeapon(int a)
        {
           String finalmessage = "";
            try{
            
            String weapon;
            
            String[] str_array;
            int i = a - 1;
            weapon = inventoryC[i];
            str_array = weapon.split("-");
            double nmon;
            double omon = getMoney();
            nmon = omon - Double.parseDouble(str_array[4]);
            if (nmon >= 0)
            {
                setMoney(nmon);
                Weapon nw = new Weapon(str_array[0], Integer.parseInt(str_array[1]), Integer.parseInt(str_array[2]), Integer.parseInt(str_array[3]), Double.parseDouble(str_array[4]));
                String weapts = weaponToString(nw);
                for (int z = 0; z < inventoryA.length; z++)
                {
                    if (inventoryA[z] == null)
                    {  
                        inventoryA[z] = weapts;
                        z = inventoryA.length;
                    }
                }
                inventoryC[i] = null;
                finalmessage = "Item purchased";
            }
            else
            {
                finalmessage = "Cannot afford the weapon.";
            }
            
           }
           catch(NullPointerException npe)
                   {
                       JOptionPane.showMessageDialog(null, "Please select a different weapon.");
                   }
           return finalmessage;
        }
		
        public String buyItem(int a)
        {
            String finalmessage = "";
            try{
            String item;
            
            String[] str_array;
            int i = a - 1;
            item = inventoryD[i];
            str_array = item.split("_");
            
         
            double nmon;
            double omon = getMoney();
            nmon = omon - Double.parseDouble(str_array[3]);
            if (nmon >= 0)
            {
                setMoney(nmon);
                Item ni = new Item(str_array[0], str_array[1], str_array[2], Double.parseDouble(str_array[3]));
                String weapts = ni.itemToString(str_array[0], str_array[1], str_array[2], str_array[3]);
                for (int z = 0; z < inventoryB.length; z++)
                {
                    if (inventoryB[z] == null)
                    {  
                        inventoryB[z] = weapts;
                        z = inventoryB.length;
                    }
                }
                finalmessage = "Item purchased";
                inventoryD[i] = null;
            }
            else
            {
                finalmessage = "Cannot afford the item.";
            }
            }
            catch(NullPointerException npe)
            {
                JOptionPane.showMessageDialog(null,"Please select a different item.");
            }
            return finalmessage;
        }
        
	public String weaponToString(Weapon wts)
	{
		String wName = wts.getName();
		String wAtk = Integer.toString(wts.getAtk());
		String wStat = Integer.toString(wts.getStat());
		String wSpeed = Integer.toString(wts.getSpeed());
                String wValue = Double.toString(wts.getValue());
                
		return(wName + "-" + wAtk + "-" + wStat + "-" + wSpeed + "-" + wValue);
	}
	
	public void weaponFromString(String wfs)
	{
		String[] str_array = wfs.split("-");
		weaponName = str_array[0];
		weaponAttack = Integer.parseInt(str_array[1]);
		weaponStat = Integer.parseInt(str_array[2]);
		weaponSpeed = Integer.parseInt(str_array[3]);
                weaponValue = Double.parseDouble(str_array[4]);
		w1.setName(weaponName);
		w1.setAtk(weaponAttack);
		w1.setStat(weaponStat);
		w1.setSpeed(weaponSpeed);
                w1.setValue(weaponValue);
	}		
	
	public Weapon getWeaponObject()
	{
		return w1;
	}
        
        public String getInventoryItem(String i, int n)
        {
            String message = "";
            switch(i)
            {
                case "A":
                {
                    message = inventoryA[n];
                    break;
                }
                case "B":
                {
                    message = inventoryB[n];
                    break;
                }
            }
            return message;   
            
        }
	
        public String switchWeaponGUI(int i)
	{
		String switch1;
		String switch2;
		String message = "";
		switch1 = inventoryA[0];
		
		if (getInvSizeA() > i)
		{
			if (inventoryA[i] == null)
			{
				message = "Switch not successful.";
			}
			else
			{
                            if(!inventoryA[i].equals("Locked"))
                            {
				switch2 = inventoryA[i];
				inventoryA[0] = switch2;
				inventoryA[i] = switch1;
				
				weaponFromString(switch2);
				
				message = "The weapons have been successfully switched.\n";
                            }
                            else
                            {
                                message = "Please select a slot that you are allowed to use.";
                            }
			}
		}
                return message;
	}
        
	public void destroyWeapon(int i)
	{
		if (getInvSizeA() > i)
		{
			if (inventoryA[i] == null)
			{
				System.out.println("Destroy not successful.");
			}
			else
			{
				if(i == 0)
				{
					System.out.println("You cannot do that.");
					System.out.println("Nothing removed.");
				}
				else
				{
					inventoryA[i] = null;
					
				}
			}
		}
	}
        
        public String destroyItemGUI(int z)
	{
            String message = "";
            int i = z - 1;
            if (getInvSizeB() > i)
		{
			if (inventoryB[i] == null)
			{
				message = "There is no item here.";
			}
			else
			{
				if (i < 0)
				{
					message = "You cannot do that.";
					message = message +"\nNothing removed.";
				}
				else
				{
                                    
                                    inventoryB[i] = null;
                                    message = "The item has been used/removed.";
				}
			}
		}
            return message;
	}
		
	public void removeWeapon(String rw)
	{
		for(int i = 0; i<inventoryA.length; i++)
		{
			if(inventoryA[i] == null)
                        {
                           //i++;
                           
                        }
                         else
                        {
                            if(inventoryA[i].equals(rw))
                            {
                                    inventoryA[i] = null;
                                    i = inventoryA.length;
                            }
                        }
                        
		}
	}
		
	public void doWeapon()
	{
		weaponName = w1.getName();
		weaponAttack = w1.getAtk();
		weaponStat = w1.getStat();
		weaponSpeed = w1.getSpeed();
                weaponValue = w1.getValue();
	}
	
	public String getWeaponStats()
	{
		String ws = w1.getWeaponStats();
		return ws;
	}
	        
        public String repairWeaponGUI()
        {
            weaponStat = w1.getStat();
            String message = w1.repairWeaponGUI(weaponStat);
            weaponStat = w1.getStat();
            return message;
        }
        
        public void upgradeWeaponHealth(int uHeal)
        {
            String weaponEquip = inventoryA[0];
            weaponFromString(weaponEquip);
            removeWeapon(weaponEquip);
            weaponStat += uHeal;
            w1.setStat(weaponStat);
            addWeaponToInv(weaponToString(getWeaponObject()));
            
        }
	
        public void upgradeWeaponAttack(int uHeal)
        {
            String weaponEquip = inventoryA[0];
            weaponFromString(weaponEquip);
            removeWeapon(weaponEquip);
            weaponAttack += uHeal;
            w1.setAtk(weaponAttack);
            addWeaponToInv(weaponToString(getWeaponObject()));
            
        }
        
	public void setName(String n)
	{
		name = n;
	}
	
	public void setHealth(int h)
	{
		health = h;
	}
	
	public void setAttack(int a)
	{
		attack = a;
	}
	
	public void setAttackWeapon(int aw)
	{
		totalatk = aw;
	}
	
	public void setDefense(int d)
	{
		defense = d;
	}
	
	public void setExp(int e)
	{
		exp = e;
	}
	
	public void setWeaponName(String w)
	{
		weaponName = w;
	}
	
	
	public void setWeaponStat(int ws2)
	{
		w1.setStat(ws2);
	}
	
	public void setWeaponAttack(int watk2)
	{
		w1.setAtk(watk2);
	}
	
	public void setWeaponSpeed(int wspeed2)
	{
		w1.setSpeed(wspeed2);
	}
        
        public void setWeaponValue(double wvalue2)
        {
            w1.setValue(wvalue2);
        }
	
	public void setMoney(double m)
	{
		money = m;
	}
	
	public double getMoney()
	{
		return money;
	}
	
	public void setInvSizeA(int a)
	{
		inventorySizeA = a;
	}
	public void setInvSizeB(int b)
	{
		inventorySizeB = b;
	}
	public int getInvSizeA()
	{
		return inventorySizeA;
	}
	public int getInvSizeB()
	{
		return inventorySizeB;
	}
	
	public void setStatus(String s)
	{
		status = s;
	}
	
	public String getStatus()
	{
		return status;
	}
	
	public String getCurrency()
	{
		return (Currency.format(money));
	}
        
        public String getAnyCurrency(double m)
        {
            return (Currency.format(m));
        }
	
	public String getName()
	{
		return name;
	}
	
	public int getHealth()
	{
		return health;
	}
	
	public int getAttack()
	{
		return attack;
	}
	
	public int getAttackWeapon()
	{
		return totalatk;
	}
	
	public int getDefense()
	{
		return defense;
	}
	
	public int getExp()
	{
		return exp;
	}
	
	public String getWeaponName()
	{
		
		return weaponName;
	}
	
	public String getItem(int z)
	{
		String ic = "N#N#N";
                int i = z - 1; 
		if (getInvSizeB() > i)
		{
			if (inventoryB[i] == null)
			{
				System.out.println("Item usage not successful.");
			}
			else
			{
				int a = i;
				String gi0;				
				String[] str_array;
				int b = a;				
				gi0 = inventoryB[b];
				str_array = gi0.split("_");
				ic = str_array[2];				
			}
		}
		return ic;
	}
	
	public void getRawInv()
	{
		for(int i = 0; i<inventoryB.length; i++)
		{
			System.out.println(inventoryB[i]);
		}
	}
	        
        public String getInventoryGUI()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;
            displaySingleInvGUI(0);
		
            for(int i = 1; i<inventoryA.length; i++)
            {
                if(inventoryA[i] != null)
                {
                        gi0 = inventoryA[i];
                        str_array = gi0.split("-");
                        finalmessage = finalmessage + "       " + i + "        " + str_array[0] + "       " + str_array[1] + "        " + str_array[2] + "        " + str_array[3] + "\n";
                }
                else
                {
                        finalmessage = finalmessage + "No Weapon" + "\n";
                }
            }
            
            return finalmessage;
        }
        
        public String getInvWepItemSlot()
        {
            String finalmessage = "";
           
            String gi0;
            String[] str_array;
            int i;
		
            for( i = 1; i<inventoryA.length; i++)
            {
                if(inventoryA[i] != null)
                {
                    if(!inventoryA[i].equals("Locked"))
                    {	
                        gi0 = inventoryA[i];
                        str_array = gi0.split("-");
                        finalmessage += Integer.toString(i) + "\n";
                    }
                    else
                    {
                        finalmessage += Integer.toString(i) + "\n";
                    }
                }
                else
                {
                   finalmessage += Integer.toString(i) + "\n";
                }
            }
            
            return finalmessage;
        }
        
        public double getWeaponValue(String wfs)
        {
            String[] str_array = wfs.split("-");
                Double vts = Double.parseDouble(str_array[4]);		
           
            return vts;
        }
        
        public String getWeaponName(String wfs)
        {
            String[] str_array = wfs.split("-");
            String nts = str_array[0];
            return nts;
        }
        
        public String getInvWepWeaponName()
        {
            String finalmessage = "";
            String gi1;
            String gi2;
            String gi3;
            String gi0;
            String[] str_array;
		
		for(int i = 1; i<inventoryA.length; i++)
		{
                    if(inventoryA[i] != null)
                    {                          
			 if(!inventoryA[i].equals("Locked"))
                         {
                            gi0 = inventoryA[i];
                            str_array = gi0.split("-");
                            finalmessage += str_array[0] + "\n";				
			 }
			else
			{
                            finalmessage += "Locked until next level" + "\n";
			}
                    }
                    else
                    {
                        finalmessage += "No Weapon" + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getInvWepAttack()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;
	
		for(int i = 1; i<inventoryA.length; i++)
		{
                    if(inventoryA[i] != null)
                    {    
                        
			if(!inventoryA[i].equals("Locked"))
                        {
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[1] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getInvWepHealth()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;

		for(int i = 1; i<inventoryA.length; i++)
		{
                    if(inventoryA[i] != null)
                    {    
                        if(!inventoryA[i].equals("Locked"))
			{
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[2] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getInvWepSpeed()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;
            
		for(int i = 1; i<inventoryA.length; i++)
		{
                    if(inventoryA[i] != null)
                    {    
                        if(!inventoryA[i].equals("Locked"))
			{
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[3] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getInvWepValue()
        {
            String finalmessage = ""; 
            String gi0;  
            String[] str_array;
		
		for(int i = 1; i<inventoryA.length; i++)
		{
                   if(inventoryA[i] != null)
                    {
			 if(!inventoryA[i].equals("Locked"))
			{
                            
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
                                finalmessage += getAnyCurrency(Double.parseDouble(str_array[4])) + "\n";
                                
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        
        public String getStoreWepItemSlot()
        {
            String finalmessage = "";
           
            String gi0;
            String[] str_array;
            int i;
		
            for( i = 0; i<inventoryC.length; i++)
            {
                if(inventoryC[i] != null)
                {
                    if(!inventoryC[i].equals("Locked"))
                    {	
                        gi0 = inventoryC[i];
                        str_array = gi0.split("-");
                        finalmessage += Integer.toString(i+1) + "\n";
                    }
                    else
                    {
                        finalmessage += Integer.toString(i+1) + "\n";
                    }
                }
                else
                {
                   finalmessage += Integer.toString(i+1) + "\n";
                }
            }
            
            return finalmessage;
        }
        
        public String getStoreWepWeaponName()
        {
            String finalmessage = "";
            String gi1;
            String gi2;
            String gi3;
            String gi0;
            String[] str_array;
		
		for(int i = 0; i<inventoryC.length; i++)
		{
                    if(inventoryC[i] != null)
                    {                          
			 if(!inventoryC[i].equals("Locked"))
                         {
                            gi0 = inventoryC[i];
                            str_array = gi0.split("-");
                            finalmessage += str_array[0] + "\n";				
			 }
			else
			{
                            finalmessage += "Locked until next level" + "\n";
			}
                    }
                    else
                    {
                        finalmessage += "No Weapon" + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getStoreWepAttack()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;
	
		for(int i = 0; i<inventoryC.length; i++)
		{
                    if(inventoryC[i] != null)
                    {    
                        
			if(!inventoryC[i].equals("Locked"))
                        {
				gi0 = inventoryC[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[1] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getStoreWepHealth()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;

		for(int i = 0; i<inventoryC.length; i++)
		{
                    if(inventoryC[i] != null)
                    {    
                        if(!inventoryC[i].equals("Locked"))
			{
				gi0 = inventoryC[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[2] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getStoreWepSpeed()
        {
            String finalmessage = "";
            String gi0;
            String[] str_array;
            
		for(int i = 0; i<inventoryC.length; i++)
		{
                    if(inventoryC[i] != null)
                    {    
                        if(!inventoryC[i].equals("Locked"))
			{
				gi0 = inventoryC[i];
				str_array = gi0.split("-");
                                finalmessage += str_array[3] + "\n";
				
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        public String getStoreWepValue()
        {
            String finalmessage = ""; 
            String gi0;  
            String[] str_array;
		
		for(int i = 0; i<inventoryC.length; i++)
		{
                   if(inventoryC[i] != null)
                    {
			 if(!inventoryC[i].equals("Locked"))
			{
                            
				gi0 = inventoryC[i];
				str_array = gi0.split("-");
                                finalmessage += getAnyCurrency(Double.parseDouble(str_array[4])) + "\n";
                                
			}
			else
			{
                            finalmessage += " " + "\n";
			}
                    }
                    else
                    {
                        finalmessage += " " + "\n";
                    }
                }
            
            return finalmessage;
        }
        
        
	public String[] getInvList()
        {
            return inventoryA;
        }
        

        
        public String getItemInvNum()
        {
           
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryB.length; i++)
            {
                    z = i + 1;
                    fm += Integer.toString(z) + "\n";  
            }
            return fm;
        }
        
           public String getItemInvName()
        {
            String gi;
            String[] str_array;
            String fm = "";
            
            for(int i = 0; i<inventoryB.length; i++)
            {
                if(inventoryB[i] !=null)
                {
                    gi = inventoryB[i];
                    str_array = gi.split("_");
                    fm += str_array[0] + "\n";
                }
                else
                {
                    fm += "No Item" + "\n";
                }
            }
            return fm;
        }         
                    
        public String getItemInvDesc()
        {
            String gi;
            String[] str_array;
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryB.length; i++)
            {
                if(inventoryB[i] !=null)
                {
                    gi = inventoryB[i];
                    str_array = gi.split("_");
                    z = i + 1;
                    fm += str_array[1] + "\n";
                }
                else
                {
                    fm += " " + "\n";
                }
            }
            return fm;
        }
        
        public String getItemInvValue()
        {
            String gi;
            String[] str_array;
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryB.length; i++)
            {
                if(inventoryB[i] !=null)
                {
                    gi = inventoryB[i];
                    str_array = gi.split("_");
                    z = i + 1;
                    fm += getAnyCurrency(Double.parseDouble(str_array[3])) + "\n";
                }
                else
                {
                    fm += " " + "\n";
                }
            }
            return fm;
        }
	
        public String getStoreItemInvNum()
        {
           
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryD.length; i++)
            {
                    z = i + 1;
                    fm += Integer.toString(z) + "\n";  
            }
            return fm;
        }
        
           public String getStoreItemInvName()
        {
            String gi;
            String[] str_array;
            String fm = "";
            
            for(int i = 0; i<inventoryD.length; i++)
            {
                if(inventoryD[i] !=null)
                {
                    gi = inventoryD[i];
                    str_array = gi.split("_");
                    fm += str_array[0] + "\n";
                }
                else
                {
                    fm += "No Item" + "\n";
                }
            }
            return fm;
        }         
                    
        public String getStoreItemInvDesc()
        {
            String gi;
            String[] str_array;
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryD.length; i++)
            {
                if(inventoryD[i] !=null)
                {
                    gi = inventoryD[i];
                    str_array = gi.split("_");
                    z = i + 1;
                    fm += str_array[1] + "\n";
                }
                else
                {
                    fm += " " + "\n";
                }
            }
            return fm;
        }
        
        public String getStoreItemInvValue()
        {
            String gi;
            String[] str_array;
            int z;
            String fm = "";
            
            for(int i = 0; i<inventoryD.length; i++)
            {
                if(inventoryD[i] !=null)
                {
                    gi = inventoryD[i];
                    str_array = gi.split("_");
                    z = i + 1;
                    fm += getAnyCurrency(Double.parseDouble(str_array[3])) + "\n";
                }
                else
                {
                    fm += " " + "\n";
                }
            }
            return fm;
        }
        
	public int getWeaponAttack()
	{
		int watk3 = w1.getAtk();
		return watk3;
	}
	
	public int getWeaponStat()
	{
		int ws1 = w1.getStat();
		return ws1;
	}
	
	public int getWeaponSpeed()
	{
		int wspeed1 = w1.getSpeed();
		return wspeed1;
	}
	
	public String getStats()
	{
		return("Name: " + name + "\n" + "Health: " + health + "\n" + "Attack: " + attack + "\n" + "Attack with Weapon: " + totalatk + "\n" + "Defense: " + defense + "\n" + "Status: " + status + "\n" + "Exp: " + exp + "\n" + "Money: " + getCurrency());
	}
	
        public String displaySingleInvGUI(int i)
        {
          String m1 = ""; 
          try
          {
                
                if(inventoryA[i] != null)
                {
                        String gi0 = inventoryA[i];
                        String[] str_array = gi0.split("-");
                        m1 = "Name: " + str_array[0] + "\nAttack: " + str_array[1] + "\nHealth: " + str_array[2] + "\nAttack Speed: " + str_array[3] + "\nWeapon Value: " + getAnyCurrency(Double.parseDouble(str_array[4]));

                }
          }
          catch(ArrayIndexOutOfBoundsException aioobe)
          {
              JOptionPane.showMessageDialog(null,"Please select an item slot that you are allowed to use.");
          }
               return m1;
        }
}