/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package Tools;


import Menus.*;
import Hero.*;
import java.awt.Color;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
/**
 *
 * @author David
 */
public class MapUtil
{
    public Map m;
    private Hero h;
    public BufferedImage image;
    public File mapLoc;
    public Color c;
    
    
    public MapUtil(Hero hero)
    {
        h = hero;
        m = new Map(h);
        mapLoc = new File("src\\Menus\\map.png");
        try
        {
            image = ImageIO.read(mapLoc);
            Point p = h.getHeroLocationPoint();
            c = new Color(image.getRGB((int)p.getX(), (int)p.getY()));
        }
        catch(IOException ex)
        {
            
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {
            
        }
        
    }
    
    public int getRed()
    {
        return c.getRed();
    }
    
    public int getGreen()
    {
        return c.getGreen();
    }
    
    public int getBlue()
    {
        return c.getBlue();
    }
    
    public Color getMapColorAt(int x, int y)
    {
        Color color = new Color(image.getRGB(x,y));
        return color;
    }
}
