package Weapons;

import Tools.RDN;
import java.io.Serializable;


public class Mace extends WeaponConverter implements Serializable 
{
    private String weaponName;
    private String weaponModifier;
    private int weaponAttack;
    private int weaponHealth;
    private double weaponValue;
   
       
    public Mace()
    {
        RDN rn = new RDN(5);
        int r = rn.RN();
        String[] mod = lightMetalModifier[r];
        weaponModifier = mod[0];
        weaponAttack = Integer.parseInt(mod[1]);
        weaponHealth = Integer.parseInt(mod[2]);
        weaponValue = Double.parseDouble(mod[3]);
        weaponName = weaponModifier + " Mace";
    }
    
    public String getWeaponStats()
    {
        return("Weapon Name: " + getWeaponName() + "\n" + "Weapon Attack: " + getWeaponAttack() + "\n" + "Weapon Health: " + getWeaponHealth() + "\n" + "Value: " + /*getAnyCurrency*/getWeaponValue() + "\n" + "Item Type: " + itemType);
    }

    /**
     * @return the weaponName
     */
    public String getWeaponName()
    {
        return weaponName;
    }

    /**
     * @param weaponName the weaponName to set
     */
    public void setWeaponName(String weaponName)
    {
        this.weaponName = weaponName;
    }

    /**
     * @return the weaponModifier
     */
    public String getWeaponModifier()
    {
        return weaponModifier;
    }

    /**
     * @param weaponModifier the weaponModifier to set
     */
    public void setWeaponModifier(String weaponModifier)
    {
        this.weaponModifier = weaponModifier;
    }

    /**
     * @return the weaponAttack
     */
    public int getWeaponAttack()
    {
        return weaponAttack;
    }

    /**
     * @param weaponAttack the weaponAttack to set
     */
    public void setWeaponAttack(int weaponAttack)
    {
        this.weaponAttack = weaponAttack;
    }

    /**
     * @return the weaponHealth
     */
    public int getWeaponHealth()
    {
        return weaponHealth;
    }

    /**
     * @param weaponHealth the weaponHealth to set
     */
    public void setWeaponHealth(int weaponHealth)
    {
        this.weaponHealth = weaponHealth;
    }

    /**
     * @return the weaponValue
     */
    public double getWeaponValue()
    {
        return weaponValue;
    }

    /**
     * @param weaponValue the weaponValue to set
     */
    public void setWeaponValue(double weaponValue)
    {
        this.weaponValue = weaponValue;
    }

  
}
