
package Weapons;

abstract class WeaponConverter
{
    public final String itemType = "Weapon";
    public abstract String getWeaponName();
    public abstract void setWeaponName(String name);
    public abstract int getWeaponAttack();
    public abstract void setWeaponAttack(int attack);
    public abstract int getWeaponHealth();
    public abstract void setWeaponHealth(int health);
    public abstract double getWeaponValue();
    public abstract void setWeaponValue(double value);
    public abstract String getWeaponStats();
    
    public final String[][] woodModifier = new String[][]{{"Oak","13","100","8.0"},
                                                          {"Elm","12","100","7.0"},
                                                          {"Ash","11","100","3.0"},
                                                          {"Redwood","11","100","6.0"},
                                                          {"Pine","9","100","4.0"}};
    
    public final String[][] lightMetalModifier = new String[][]{{"Iron","16","100","8.5"},
                                                                {"Steel","17","100","9.5"},
                                                                {"Diamond","20","100","12.5"},
                                                                {"Gold","8","100","14.5"},
                                                                {"Wooden","13","100","6.5"}};
    
    public final String[][] heavyMetalModifier = new String[][]{{"Iron","26","100","11"},
                                                                {"Steel","27","100","12"},
                                                                {"Diamond","30","100","15"},
                                                                {"Gold","18","100","17"},
                                                                {"Wooden","22","100","9"}};
}