public class printLogo
{
	public printLogo()
	{
		loadLogo();
	}
	
	public static void loadLogo()
	{
		System.out.println("    dP   dP   dP          dP											");
		System.out.println("    88   88   88          88											");
		System.out.println("    88  .8P  .8P .d8888b. 88 .d8888b. .d8888b. 88d8b.d8b. .d8888b.		");
		System.out.println("    88  d8'  d8' 88ooood8 88 88'  `'' 88'  `88 88'`88'`88 88ooood8		");
		System.out.println("    88.d8P8.d8P  88.  ... 88 88.  ... 88.  .88 88  88  88 88.  ...		");
		System.out.println("    8888' Y88'   `88888P' dP `88888P' `88888P' dP  dP  dP `88888P'		");
		System.out.println("																		");		
		System.out.println("      dP																");		
		System.out.println("      88																");
		System.out.println("    d8888P .d8888b.														");			
		System.out.println("      88   88'  `88														");			
		System.out.println("      88   88.  .88														");
		System.out.println("      dP   `88888P'														");
		System.out.println("																		");
		System.out.println("    888888ba                    oo       dP d8							");	
		System.out.println("    88    `8b                            88 88							");	
		System.out.println("    88     88 .d8888b. dP   .dP dP .d888b88 .P .d8888b.					");		
		System.out.println("    88     88 88'  `88 88   d8' 88 88'  `88    Y8ooooo.					");	
		System.out.println("    88    .8P 88.  .88 88 .88'  88 88.  .88          88					");
		System.out.println("    8888888P  `88888P8 8888P'   dP `88888P8    `88888P'					");
		System.out.println("																		");
		System.out.println("     888888ba   888888ba   .88888.										");	
		System.out.println("     88    `8b  88    `8b d8'   `88										");	
		System.out.println("    a88aaaa8P' a88aaaa8P' 88											");
		System.out.println("     88   `8b.  88        88   YP88										");
		System.out.println("     88     88  88        Y8.   .88										");	
		System.out.println("     dP     dP  dP         `88888'										");
		System.out.println("																		");
	}
}
/* This program was created by David Eisenberg
	Its an easier way to create mulitiple random numbers.
	The program recieves the range (0-whatever) and returns the random number.
*/

import java.util.Random;
import java.io.Serializable;

public class RDN implements Serializable
{
	private int randomNumber;
	private int rIndex = 1;
	
	public RDN(int i)
	{
		rIndex = i;
	}
	
	public int RN()
	{
		Random generator = new Random();
		randomNumber = generator.nextInt(rIndex);
		return randomNumber;
	}
}
import java.io.*;
import java.util.*;

public class MainGame
{
	static String name = "";
	static Scanner userInput = new Scanner (System.in);
	static Hero hero = new Hero(); //create new hero
	static Enemy enemy = new Enemy(); //create new enemy
	static Hero heroLoad;
	
	public static void main(String args[])
	{	
		
		printLogo pl = new printLogo(); //load the welcome logo
		createVersion();
		mainMenu();
	}
	
	public static void mainMenu()
	{
		String menuoption;
		int error = 0;
		do
		{
			System.out.println("Enter '1' to start a new game, '2' to load previous game, and '3' to Exit:");
			menuoption = userInput.next();
			if(isInt(menuoption) == true)
			{
				switch(Integer.parseInt(menuoption))
				{
					case 1:
					{
						newGame(); 
						error = 1;
						break;
					} //create new game
					case 2:
					{
						System.out.println("LOADING..........");
						loadGame();
						error = 1;
						break;
					} //load previous game save
					case 3:
					{
						System.out.println("Goodbye.");
						error = 1;
						break;
					}
					default:
					{
						break;
					}
				}
			}
		}
		while (error !=1);
	}
	
	public static void newGame()
	{	
		String savename = "";
		System.out.print("Enter name: ");
		name = userInput.next();
		hero.setName(name);
		savename = name + ".ser";
		saveGame(savename, hero);
		Battle b1 = new Battle(savename);	
	}
	
	public static void loadGame()
	{
		ObjectInputStream input;
		String loadName;
		System.out.println("Enter hero name, to go back to the main menu type (mm): ");
		name = userInput.next();
		loadName = name + ".ser";
		if (name.equals("mm"))
		{
			mainMenu();
		}
		else
		{
			try
			{
				input = new ObjectInputStream(new FileInputStream(loadName));
				heroLoad = (Hero)input.readObject();
				//saveGame(loadName, heroLoad);
				Battle b3 = new Battle(loadName);			
			}
			
			catch(EOFException eofe)
			{
				System.out.println("Filename not found, please try again.");
				
				loadGame();
			}
			
			catch(ClassNotFoundException cnfe)
			{
				System.out.println("Filename not found, please try again.");
				loadGame();
			}
			
			catch(IOException ioe)
			{
				System.out.println("Filename not found, please try again.");
				loadGame();
			}
		}
	}
	
	public static void saveGame(String n, Hero hc) //possibly put save and load in its own class.
	{
		try
		{
			ObjectOutputStream output;
			output = new ObjectOutputStream (new FileOutputStream(n));
			output.writeObject(hc);
			output.flush();
			output.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}

	public static void createVersion()
	{
		double version = 0.0000;
		Scanner inputV;
		Formatter outputV;
		try
		{
			inputV = new Scanner(new File("version.txt"));
			while(inputV.hasNext())
			{
				version = inputV.nextDouble();
			}
			inputV.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		
		version = version + .0001;
		
		try
		{
			outputV = new Formatter("version.txt");
			outputV.format("%f", version);
			outputV.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		System.out.println("Version: " + version);
	}
}
import java.util.*;
import java.io.Serializable;
import java.io.*;

public class Item implements Serializable
{
	private String name; //name of item
	private String mod; // Modifier
	private String category; //Category
	private String itemName; //Final Item Name
	
	RDN itemCat = new RDN(4); //Item Category
	RDN itemAS = new RDN(5);//Anti-status
	RDN torp = new RDN(2); //Temporary or Permanent
	RDN itemPPE = new RDN(4);//Permanent PE
	RDN itemTPE = new RDN(2);//Temporary PE
	RDN rareChance = new RDN(8);//Rare Chance
	RDN itemRare = new RDN(3);//Rare Item
	RDN itemOther = new RDN(1);//Other Item
	RDN itemModifer = new RDN(20);//Item modifier chance, 5 items random number between 0 and 19
	
	private String[] itemCatagory = {"Anti-status", "Point Enhancers", "Rare", "Other"};//4
	private String[] asNames = {"Poison", "Burn", "Paralyze", "Sleep", "Confusion"};//5
	private String[] ppeNames = {"Health", "Permanent Attack", "Weapon Health", "Permanent Weapon Attack"};//4
	private String[] rareNames = {"Cure All", "Exp Increase", "Level Increase"};//3
	private String[] tpeNames = {"Temporary Attack", "Temporary Weapon Attack"};//2
	private String[] otherNames = {"Repel"};//1
	private String[] modifers = {"Basic", "Super", "Mega", "Ultra", "Hyper"};//5
	
	public Item()
	{
		int itemCatagoryRDN = itemCat.RN(); 
		int itemASRDN = itemAS.RN();
		int torpRDN = torp.RN();
		int itemPPERDN = itemPPE.RN();
		int itemTPERDN = itemTPE.RN();
		int itemOtherRDN = itemOther.RN();
		int itemRareRDN = itemRare.RN();
		int rareChanceRDN = rareChance.RN();
		int itemModiferRDN = itemModifer.RN();
		
		if (itemModiferRDN <= 10)
			mod = modifers[0];
		if (itemModiferRDN >= 11 && itemModiferRDN <= 13)
			mod = modifers[1];
		if (itemModiferRDN >= 14 && itemModiferRDN <= 16)
			mod = modifers[2];
		if (itemModiferRDN >= 17 && itemModiferRDN <= 18)
			mod = modifers[3];
		if(itemModiferRDN == 19)
			mod = modifers[4];
			
		
		switch(itemCatagoryRDN)
		{
			case 0:
			{
				category = itemCatagory[itemCatagoryRDN];
				
				switch(itemASRDN)
				{
					case 0:
					{
						name = asNames[itemASRDN];
						
						break;
					}
					case 1:
					{
						name = asNames[itemASRDN];
						
						break;
					}
					case 2:
					{
						name = asNames[itemASRDN];
						
						break;
					}
					case 3:
					{
						name = asNames[itemASRDN];
						
						break;
					}
					case 4:
					{
						name = asNames[itemASRDN];
						
						break;
					}
				}
				name = "Anti-" + name;
				break;
			}
			case 1:
			{
				category = itemCatagory[itemCatagoryRDN];
				
				switch(torpRDN)
				{
					case 0:
					{
						switch(itemPPERDN)
						{
							case 0:
							{
								name = ppeNames[itemPPERDN];
								
								break;
							}
							case 1:
							{
								name = ppeNames[itemPPERDN];
								
								break;
							}
							case 2:
							{
								name = ppeNames[itemPPERDN];
								
								break;
							}
							case 3:
							{
								name = ppeNames[itemPPERDN];
								
								break;
							}
						}
						break;
					}
					case 1:
					{
						switch(itemTPERDN)
						{
							case 0:
							{
								name = tpeNames[itemTPERDN];
								
								break;
							}
							case 1:
							{
								name = tpeNames[itemTPERDN];
							
								break;
							}
						}						
						break;
					}
				}
				name = name + " " + "Increase";
				break;
			}
			case 2:
			{
				category = itemCatagory[itemCatagoryRDN];
				
			
				if(rareChanceRDN == 1 || rareChanceRDN == 2 || rareChanceRDN == 4)
				{
					switch(itemRareRDN)
					{
						case 0:
						{
							name = rareNames[itemRareRDN];
							
							break;
						}
						case 1:
						{
							name = rareNames[itemRareRDN];
							
							break;
						}
						case 2:
						{
							name = rareNames[itemRareRDN];
							
							break;
						}						
					}
				}
				else if(rareChanceRDN == 0 || rareChanceRDN == 3 || rareChanceRDN == 5 || rareChanceRDN == 6 || rareChanceRDN == 7)
				{
					name = ppeNames[0] + " Increase";
					
				}
				
				break;
			}
			case 3:
			{
				category = itemCatagory[itemCatagoryRDN];
				
				switch(itemOtherRDN)
				{
					case 0:
					{
						name = otherNames[itemOtherRDN];
					
						break;
					}
				}
				break;
			}
		}
		itemName = mod + " " + name;	
	}
				
	public void setName (String n)
	{
		name = n;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setMod (String m)
	{
		mod = m;
	}
	
	public String getMod()
	{
		return mod;
	}
	
	public void setCategory(String c)
	{
		category = c;
	}
	
	public String getCategory()
	{
		return category;
	}
	
	public String getItemName()
	{
		return itemName;
	}
		
	public String getItemStats()
	{
		return("Item: " + itemName + "\n" + "Item Category: " + category);
	}
}
import java.io.Serializable;
import java.io.*;
import java.util.*;

public class Inventory implements Serializable
{	
	public Inventory(Hero h)
	{
		invMainMenu(h);
	}
	
	public static void invMainMenu(Hero h)
	{
		lb();
		String invmenu;
		String invsubmenu;
		int error = 0;
		Scanner input = new Scanner (System.in);
		
		do
		{
			System.out.println("\n\n\n\n\n\n\n\n\n\n\n");
			System.out.println("This option is an Beta v1 build.");
			System.out.println("Please select what you would like to do: ");
			System.out.println("1. View Weapon Inventory");
			System.out.println("2. Switch your current weapon.");
			System.out.println("3. Remove a weapon from the inventory.");
			System.out.println("4. Attempt to repair your current weapon");
			System.out.println("------If attempt fails, it could reduce the weapon health.");
			System.out.println("5. View Item Inventory.");
			System.out.println("5. -DOES NOT WORK- Use an item in your inventory.");
			System.out.println("6. -DOES NOT WORK- Remove an item from the inventory.");
			System.out.println("8. -DOES NOT WORK- Check how many slots you have left in your inventory.");
			System.out.println("20. *******TESTING ONLY******** Add random weapon to inventory.");
			System.out.println("0. Return to previous menu.");
			invmenu = input.next();
			if(isInt(invmenu) == true)
			{
				switch(Integer.parseInt(invmenu))
				{
					case 1:
					{
						h.getInventory();
						pauseProg();
						break;
					}
					case 2:
					{
						h.getInventory();
						System.out.println("\nPlease enter the number of the weapon that you want to switch out: ");
						invsubmenu = input.next();
						
						h.switchWeapon(Integer.parseInt(invsubmenu));
						break;
					}
					case 3:
					{
						h.getInventory();
						System.out.println("\nPlease enter the number of the weapon that you want to remove:");
						invsubmenu = input.next();
						h.destroyWeapon(Integer.parseInt(invsubmenu));
						break;
					}
					case 4:
					{
						String ws1 = h.weaponToString(h.getWeaponObject()); 
						h.repairWeapon(); 
						h.removeWeapon(ws1); 
						if (!h.getWeaponStats().equals(0))
						{
							h.addWeaponToInv(h.weaponToString(h.getWeaponObject())); 
						}
						break;
					}
					case 5:
					{
						h.getItemInventory();
						pauseProg();
						break;
					}
					case 20:
					{
						Weapon nrw = new Weapon();
						String nws = h.weaponToString(nrw);
						
						h.addWeaponToInv(nws);
						
						break;
					}
				}
			}
		}
		while(!invmenu.equals("0"));
	}
	
	public static void pauseProg()
	{
		System.out.println("Press enter to continue...");
		Scanner keyboard = new Scanner(System.in);
		keyboard.nextLine();
		lb();
	}
	public static void lb()
	{
		System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}
import java.io.Serializable;
import java.util.*;

public class Hero implements Serializable
{
	private String name; //default values
	private int health; // 300
	private int attack; // 10
	private int defense; // 10
	private int exp; // 0 
	Weapon w1 = new Weapon();
	
	private String weaponName; //Weapon Name
	private int weaponAttack; //Weapon Attack Stats
	private int weaponStat; //Weapon Health
	private int weaponSpeed; //Weapon Speed
	private int inventorySizeA = 10; //10 weapons
	private String inventoryA[] = new String[inventorySizeA]; //Weapon Inventory
	private int inventorySizeB = 10; //10 items
	private String inventoryB[] = new String[inventorySizeB];  //Item Inventory	
	private int totalatk;
	
	public Hero()
	{
		setName("");
		setHealth(300);
		doWeapon();
		setDefense(10);
		setExp(0);
		totalatk = 10 + weaponAttack;
		setAttack(10);
		setAttackWeapon(totalatk);
		addWeaponToInv(weaponToString(w1));
	}
	
	public void addWeaponToInv(String ws1)
	{
		for(int i = 0; i<inventoryA.length; i++)
		{
			if(inventoryA[i] == null)
			{
				inventoryA[i] = ws1;
				i = inventoryA.length;
			}
		}
	}
	
	public void addItemToInv(String it1)
	{
		for(int i = 0; i<inventoryB.length; i++)
		{
			if(inventoryB[i] == null)
			{
				inventoryB[i] = it1;
				i = inventoryB.length;
			}
		}
	}
	
	public String weaponToString(Weapon wts)
	{
		String wName = wts.getName();
		String wAtk = Integer.toString(wts.getAtk());
		String wStat = Integer.toString(wts.getStat());
		String wSpeed = Integer.toString(wts.getSpeed());
		return(wName + "-" + wAtk + "-" + wStat + "-" + wSpeed);
	}
	
	public void weaponFromString(String wfs)
	{
		String[] str_array = wfs.split("-");
		weaponName = str_array[0];
		weaponAttack = Integer.parseInt(str_array[1]);
		weaponStat = Integer.parseInt(str_array[2]);
		weaponSpeed = Integer.parseInt(str_array[3]);
		w1.setName(weaponName);
		w1.setAtk(weaponAttack);
		w1.setStat(weaponStat);
		w1.setSpeed(weaponSpeed);
	}		
	
	public Weapon getWeaponObject()
	{
		return w1;
	}
	
	public void setWeaponObject(Weapon sw)
	{
		w1 = sw;
	}
	
	public void switchWeapon(int i)
	{
		String switch1;
		String switch2;
		
		switch1 = inventoryA[0];
		switch2 = inventoryA[i];
		
		inventoryA[0] = switch2;
		inventoryA[i] = switch1;
		
		weaponFromString(switch2);
		
		System.out.println("The weapons have been successfully switched.\n");
		displaySingleInv(0);
	}
	
	public void destroyWeapon(int i)
	{
		if(i == 0)
		{
			System.out.println("You cannot do that.");
			System.out.println("Nothing removed.");
		}
		else
		{
			String dWeapon = inventoryA[i];
			inventoryA[i] = null;
			
		}
	}	
		
	public void removeWeapon(String rw)
	{
		for(int i = 0; i<inventoryA.length; i++)
		{
			if(inventoryA[i].equals(rw))
			{
				inventoryA[i] = null;
				i = inventoryA.length;
			}
		}
	}
	
	public void doWeapon()
	{
		weaponName = w1.getName();
		weaponAttack = w1.getAtk();
		weaponStat = w1.getStat();
		weaponSpeed = w1.getSpeed();
	}
	
	public String getWeaponStats()
	{
		String ws = w1.getWeaponStats();
		return ws;
	}
	
	public void repairWeapon()
	{
		weaponStat = (w1.getStat());
		w1.repairWeapon(weaponStat);
		weaponStat = (w1.getStat());		
	}
	
	public void upgradeSpeed()
	{
		weaponSpeed = (w1.getSpeed());
		w1.upgradeWeaponSpeed(weaponSpeed);
		weaponSpeed = (w1.getSpeed());
	}
	
	public void setName(String n)
	{
		name = n;
	}
	
	public void setHealth(int h)
	{
		health = h;
	}
	
	public void setAttack(int a)
	{
		attack = a;
	}
	
	public void setAttackWeapon(int aw)
	{
		totalatk = aw;
	}
	
	public void setDefense(int d)
	{
		defense = d;
	}
	
	public void setExp(int e)
	{
		exp = e;
	}
	
	public void setWeaponName(String w)
	{
		weaponName = w;
	}
	
	/*public void setInventorySize(int is)
	{
		inventorySize = is;
	}*/
	
	public void setWeaponStat(int ws2)
	{
		w1.setStat(ws2);
	}
	
	public void setWeaponAttack(int watk2)
	{
		w1.setAtk(watk2);
	}
	
	public void setWeaponSpeed(int wspeed2)
	{
		w1.setSpeed(wspeed2);
	}
	
	public String getName()
	{
		return name;
	}
	
	public int getHealth()
	{
		return health;
	}
	
	public int getAttack()
	{
		return attack;
	}
	
	public int getAttackWeapon()
	{
		return totalatk;
	}
	
	public int getDefense()
	{
		return defense;
	}
	
	public int getExp()
	{
		return exp;
	}
	
	public String getWeaponName()
	{
		
		return weaponName;
	}
	
	/*public int getInventorySize()
	{
		return inventorySize;
	}*/
	
	public void getInventory()
	{
		String gi1;
		String gi2;
		String gi3;
		String gi0;
		String[] str_array;
		displaySingleInv(0);
		
		System.out.println("--Item Slot-----Weapon Name-------------Attack----Health----Speed----");
		for(int i = 1; i<10; i++)
		{
			if(inventoryA[i] != null)
			{
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
				System.out.println("       " + i + "        " + str_array[0] + "       " + str_array[1] + "        " + str_array[2] + "        " + str_array[3]);
			}
			else
			{
				System.out.println("No Weapon");
			}
		}
		for(int i = 10; i<inventoryA.length; i++)
		{
			if(inventoryA[i] != null)
			{	
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
				System.out.println("       " + i + "       " + str_array[0] + "       " + str_array[1] + "        " + str_array[2] + "        " + str_array[3]);
			}
			else
			{
				System.out.println("No Weapon");
			}
		}
	}
	
	public void getItemInventory()
	{
		for(int i = 1; i<inventoryB.length; i++)
		{
			System.out.println(inventoryB[i]);
		}
	}
	
	public int getWeaponAttack()
	{
		int watk3 = w1.getAtk();
		return watk3;
	}
	
	public int getWeaponStat()
	{
		int ws1 = w1.getStat();
		return ws1;
	}
	
	public int getWeaponSpeed()
	{
		int wspeed1 = w1.getSpeed();
		return wspeed1;
	}
	
	public String getStats()
	{
		return("Name: " + name + "\n" + "Health: " + health + "\n" + "Attack: " + attack + "\n" + "Attack with Weapon: " + totalatk + "\n" + "Defense: " + defense + "\n" + "Exp: " + exp + "\n" + "Weapon: " + weaponName + "\n");
	}
	
	public void displaySingleInv(int i)
	{
		if(inventoryA[i] != null)
		{
			String gi1;
			String gi2;
			String gi3;
			String gi0 = inventoryA[i];
			String[] str_array = gi0.split("-");
			System.out.println("Currently Equipped...");
			System.out.println("Name: " + str_array[0] + "\nAttack: " + str_array[1] + "\nHealth: " + str_array[2] + "\nAttack Speed: " + str_array[3]);
			System.out.println("\n");
		}
	}
}
import java.io.Serializable;
import java.io.*;
import java.util.*;

public class Explore implements Serializable
{
	private String heroname; //saved game name
	
	public Explore(String hn)
	{
		heroname = hn;
		loadHero(heroname);
	}
	
	public static void loadHero(String n)
	{
		ObjectInputStream input;
		Hero heroLoad;
		
		try
		{
			input = new ObjectInputStream(new FileInputStream(n));
			heroLoad = (Hero)input.readObject();
			ExploreMap(heroLoad);
		}
		
		catch(EOFException eofe)
		{
			return;
		}
		catch(ClassNotFoundException cnfe)
		{
			System.out.println();
		}
		
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	public static void ExploreMap(Hero h)
	{
		
		System.out.println("---------------------");
		System.out.println("----Explore Stuff----");
		System.out.println("---------------------");
		Scanner input = new Scanner (System.in);
		String menuopt;
		String exit = "zero";
		do
		{
			System.out.println("Your current stats are:\n");
			System.out.println(h.getStats());	
			System.out.println("Your current weapon selected is:\n");
			System.out.println(h.getWeaponStats());
		
			System.out.println("Explore Menu: **ALPHA VERSION**\n");
			System.out.println("1.-.");
			System.out.println("2.-.");
			System.out.println("3. Check Weapon Inventory.");
			System.out.println("0. Exit Game.");
			System.out.println("20. Battle Again. **FOR TESTING PURPOSES**");
			System.out.println("Please select a number.\n");
			menuopt = input.next();
			if(isInt(menuopt) == true)
			{
				lb();
				switch(Integer.parseInt(menuopt))
				{
					case 0: 
					{
						exit = "exit";
						break;
					}
					
					case 1: 
					{
						break; 
					}
					case 2: 
					{		
						break; 
					}
					case 3:
					{
						String gs = h.getName() + ".ser";
						ObjectOutputStream oos1;
						try
						{
							oos1 = new ObjectOutputStream (new FileOutputStream(gs));
							oos1.writeObject(h);
							oos1.flush();
							oos1.close();				
						}
						catch(IOException ioe)
						{
							ioe.printStackTrace();
						}
						Enemy e = new Enemy();
						Inventory i1 = new Inventory(h);
						pauseProg();
						break;
					}
					
					case 20:
					{
						String gs = h.getName() + ".ser";
						ObjectOutputStream oos1;
						try
						{
							oos1 = new ObjectOutputStream (new FileOutputStream(gs));
							oos1.writeObject(h);
							oos1.flush();
							oos1.close();
						}
						catch(IOException ioe)
						{
							ioe.printStackTrace();
						}
						Enemy e = new Enemy();
						Battle b1 = new Battle(gs);
						break;
					}
						
					default:
					{
						lb();
						System.out.println("Please enter a valid menu choice.");
						pauseProg();
						break;
					}
				}
			}
			
			else
			{
				lb();
				System.out.println("Please enter a valid menu choice.");
				pauseProg();
			}
		}
		while(!exit.equals("exit"));
		if (exit.equals("exit"));
		{
			String gs = h.getName() + ".ser";
			ObjectOutputStream oos1;
			try
			{
				oos1 = new ObjectOutputStream (new FileOutputStream(gs));
				oos1.writeObject(h);
				oos1.flush();
				oos1.close();				
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
			}
		}
	}
	
	public static void pauseProg()
	{
		System.out.println("Press enter to continue...");
		Scanner keyboard = new Scanner(System.in);
		keyboard.nextLine();
		lb();
	}
	public static void lb()
	{
		System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}
import java.util.*;
import java.util.Random;

public class Enemy
{
	private String name; //default values
	private int health; // 100
	private int attack; // 10
	private int defense; // 10
	private int exp; // 0 
	RDN rn101 = new RDN(101);
	RDN rn11 = new RDN(11);
	
	private int randomHealth = rn101.RN();
	private int randomAttack = rn11.RN();
	private int randomDefense = rn11.RN();
	private int randomExp = rn11.RN();
	private String[] monsterNames = {"Zombie", "Skeleton", "Spider", "Creeper", "Dragon", "Evil Bunny", "Wolf", "Ogre", "Demon"};
	
	public Enemy()
	{
		RDN rn5 = new RDN(9);
		int randomMonster = rn5.RN();
		name = monsterNames[randomMonster];
		setName(name);
		if (randomHealth <= 25)
		{
			randomHealth =+ 50;
			setHealth(randomHealth);
		}
		if ((randomHealth >= 25) && (randomHealth <= 50))
		{
			randomHealth =+ 25;
			setHealth(randomHealth);
		}
		
		if (randomHealth >= 51)
		{
			setHealth(randomHealth);
		}

		setAttack(randomAttack);
		setDefense(randomDefense);
		setExp(randomExp);
	}
	
	public Enemy(String n, int h, int a, int d, int e)
	{
		setName(n);
		setHealth(h);
		setAttack(a);
		setDefense(d);
		setExp(e);
	}
	
	public void setName(String n)
	{
		name = n;
	}
	
	public void setHealth(int h)
	{
		health = h;
	}
	
	public void setAttack(int a)
	{
		attack = a;
	}
	
	public void setDefense(int d)
	{
		defense = d;
	}
	
	public void setExp(int e)
	{
		exp = e;
	}
	
	public String getName()
	{
		return name;
	}
	
	public int getHealth()
	{
		return health;
	}
	
	public int getAttack()
	{
		return attack;
	}
	
	public int getDefense()
	{
		return defense;
	}
	
	public int getExp()
	{
		return exp;
	}
		
	public String getStats()
	{
		return("Name: " + name + "\n" + "Health: " + health + "\n" + "Attack: " + attack + "\n" + "Defense: " + defense + "\n" + "Exp: " + exp + "\n");
	}
}	
import java.io.Serializable;
import java.io.*;
import java.util.*;

public class Battle implements Serializable
{
	private String heroname; //saved game name
	
	public Battle(String hn)
	{
		ObjectInputStream input;
		Hero heroLoad;
		
		try
		{
			input = new ObjectInputStream(new FileInputStream(hn));
			heroLoad = (Hero)input.readObject();
			Enemy enemy = new Enemy();
			Fight(heroLoad, enemy);
		}
		
		catch(EOFException eofe)
		{
			return;
		}
		catch(ClassNotFoundException cnfe)
		{
			System.out.println();
		}
		
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static void Fight(Hero h, Enemy e)
	{
		int enemyStartHealth;
		lb();
		System.out.println("---------------------");
		System.out.println("--The Battle Begins--");
		System.out.println("---------------------");
		
		String menuopt;
		String invmenu;
		String debugmenuopt;
		String debugsubmenu;
		String invsubmenu;
		int error = 0;
		Scanner input = new Scanner (System.in);
		enemyStartHealth = e.getHealth();
		boolean getExp = false;
		do
		{
			System.out.println("Your current stats are:\n");
			System.out.println(h.getStats());	
			System.out.println("Your current weapon selected is:\n");
			System.out.println(h.getWeaponStats());
			System.out.println("The enemies current stats are:\n");
			System.out.println(e.getStats());
			
			System.out.println("Battle Menu:\n");
			System.out.println("1. Attack the enemy with your fists.");
			System.out.println("2. Attack the enemy with " + h.getWeaponName());
			System.out.println("3. Check inventory...(Beta Version).");
			System.out.println("0. Try to escape.");
			System.out.println("Please select a number.\n");
			menuopt = input.next();
			if(isInt(menuopt) == true)
			{
				lb();
				switch(Integer.parseInt(menuopt))
				{
					case 1: 
					{
						RDN r = new RDN(15);
						int temprdn;
						int temprdn2;
						temprdn = r.RN();
						temprdn2 = r.RN();
						System.out.println(h.getName() + " attacks the " + e.getName() + " and does " + temprdn + " damage.");
						e.setHealth(e.getHealth() - temprdn);
						System.out.println("The " + e.getName() + " now has " + e.getHealth() + " health left.");
						System.out.println("The " + e.getName() + " attacks " + h.getName() + " and does " + temprdn2 + " damage.");
						h.setHealth(h.getHealth() - temprdn2);
						System.out.println(h.getName() + " now has " + h.getHealth() + " health left."); 
						pauseProg(); 
						getExp = true;
						break; 
					}
					case 2: 
					{		
						int chkbroken = h.getWeaponStat();
						if (chkbroken > 0)
						{
							RDN r = new RDN(15);
							RDN r2 = new RDN (6); 
							int decWepHlth = r2.RN();//decreasing weapon health 
							int temprdn;
							int temprdn2;
							temprdn = r.RN();
							int totaldamage = temprdn + h.getAttackWeapon();
							temprdn2 = r.RN() + r.RN();
							System.out.println(h.getName() + " attacks the " + e.getName() + " and does " + totaldamage + " damage.");
							e.setHealth(e.getHealth() - totaldamage);
							System.out.println("The " + e.getName() + " now has " + e.getHealth() + " health left.");
							System.out.println("The " + e.getName() + " attacks " + h.getName() + " and does " + temprdn2 + " damage.");
							h.setHealth(h.getHealth() - temprdn2);
							System.out.println(h.getName() + " now has " + h.getHealth() + " health left."); 
							getExp = true;
							String ws1 = h.weaponToString(h.getWeaponObject()); 
							h.removeWeapon(ws1); 	
							int weaponstatchg = h.getWeaponStat() - decWepHlth;
							h.setWeaponStat(weaponstatchg);
							h.addWeaponToInv(h.weaponToString(h.getWeaponObject()));
						}
						else
						{
							String ws1 = h.weaponToString(h.getWeaponObject()); 
							System.out.println("Your weapon is broken.");// you can either change weapons or use your fists.");
							h.removeWeapon(ws1);
							System.out.println("It has been removed from your inventory...You need to select a new one.");
						}
						pauseProg();
						break; 
					}
					case 3:
					{
						Inventory i1 = new Inventory(h);
						break;
					}
					case 0: 
					{
						getExp = false;
						RDN es = new RDN(11);
						int escape = es.RN();
						int newhealth;
						newhealth = e.getHealth() + escape;
						if (escape % 2 == 0)
						{
							e.setHealth(-5);
							System.out.println("You have successfully escaped...");
							enemyStartHealth = 0;
						}
						else
							e.setHealth(newhealth);
						break;
					}
					case 1988:
					{
						int exit = 0;
						do
						{	
							System.out.println("Welcome to the debug menu");
							System.out.println("Type the name of the object you want to edit.");
							System.out.println("Choices (Case Sensitive): Hero, Enemy, Weapon.");
							System.out.println("Type anything else to exit to the game.");
							debugmenuopt = input.next();
						
							switch(debugmenuopt)
							{
								case "Hero":
								{
									System.out.println("Please type what you would like to do with the Hero object: ");
									System.out.println("Choices (Case Sensitive): getStats, setName, setAttack, setDefense, setExp,");
									System.out.println("setHealth.");
									debugsubmenu = input.next();
									switch(debugsubmenu)
									{
										case "getStats":
										{
											System.out.println(h.getStats());
											break;
										}
										case "setName":
										{
											System.out.println("Enter new name: ");
											h.setName(input.next());
											System.out.println("The name has been changed to " + h.getName());
											break;
										}
										case "setAttack":
										{
											System.out.println("Enter new Attack: ");
											h.setAttack(Integer.parseInt(input.next()));
											System.out.println("The Attack has been changed to " + h.getAttack());
											break;
										}
										case "setDefense":
										{
											System.out.println("Enter new Defense: ");
											h.setDefense(Integer.parseInt(input.next()));
											System.out.println("The Defense has been changed to " + h.getDefense());
											break;
										}
										case "setExp":
										{
											System.out.println("Enter new Exp: "); 
											h.setExp(Integer.parseInt(input.next()));
											System.out.println("The Exp has been changed to " + h.getExp());
											break;
										}
										case "setHealth":
										{
											System.out.println("Enter new Health: ");
											h.setHealth(Integer.parseInt(input.next()));
											System.out.println("The Health has been changed to " + h.getHealth());
											break;
										}										
										default: 
										{
											break;
										}
									}
									break;
								}
								
								case "Enemy":
								{
									System.out.println("Please type what you would like to do with the Enemy object: ");
									System.out.println("Choices (Case Sensitive): getStats, setName, setAttack, setDefense.");
									debugsubmenu = input.next();
									switch(debugsubmenu)
									{
										case "getStats":
										{
											System.out.println(e.getStats());
											break;
										}
										case "setName":
										{
											System.out.println("Enter new name: ");
											e.setName(input.next());
											System.out.println("The name has been changed to " + e.getName());
											break;
										}
										case "setAttack":
										{
											System.out.println("Enter new Attack: ");
											e.setAttack(Integer.parseInt(input.next()));
											System.out.println("The Attack has been changed to " + e.getAttack()); 
											break;
										}
										case "setDefense":
										{
											System.out.println("Enter new Defence: ");
											e.setDefense(Integer.parseInt(input.next()));
											System.out.println("The Defense has been changed to " + e.getDefense());
											break;
										}
										default: 
										{
											break;
										}
									}
									break;
								}
								
								case "Weapon":
								{
									System.out.println("Please type what you would like to do with the Weapon object: ");
									System.out.println("Choices (Case Sensitive): getStats, repairWeapon, removeWeapon, setStat");
									debugsubmenu = input.next();
									switch(debugsubmenu)
									{
										case "getStats":
										{
											System.out.println(h.getWeaponStats());
											break;
										}
										case "repairWeapon":
										{
											String ws1 = h.weaponToString(h.getWeaponObject()); 
											h.repairWeapon(); 
											h.removeWeapon(ws1); 
											h.addWeaponToInv(h.weaponToString(h.getWeaponObject())); 
											break;
										}
										case "removeWeapon":
										{
											System.out.println("Type the name of the weapon you want to remove from the inventory: ");
											h.removeWeapon(input.next());
											break;
										}
										//case "setName":{System.out.println("Enter new name: "); w.setName(input.next()); System.out.println("The name has been changed to " + e.getName()); break;}
										case "setStat":
										{
											String ws1 = h.weaponToString(h.getWeaponObject()); 
											
											System.out.println("Enter new Stat: ");
											h.setWeaponStat(Integer.parseInt(input.next()));
											h.removeWeapon(ws1); 
											h.addWeaponToInv(h.weaponToString(h.getWeaponObject())); 
											System.out.println("The Stat has been changed to " + h.getWeaponStat());
											break;
										}
										default: 
										{
											break;
										}
									}
									
									break;
								}
								
								default:
								{
									exit = 1;
									break;
								}
							}
						}
						while (exit != 1);
						
						lb();
						pauseProg();
						break;
					}
					default:
					{
						lb();
						System.out.println("Please enter a valid menu choice.");
						pauseProg();
						break;
					}
				}
			}
			
			else
			{
				lb();
				System.out.println("Please enter a valid menu choice.");
				pauseProg();
			}
		} while (e.getHealth() >= 0 && h.getHealth() >= 0);
		int ehealth = e.getHealth();
		
		if (ehealth <= 0)
		{
			System.out.println("The enemy is dead.");
			if (getExp == true)
			{
				int expold;
				int expnew;
				RDN rExp = new RDN(3);
				int rdExp = rExp.RN();
				int expchange = enemyStartHealth * (rdExp + 1);
				expold = h.getExp();
				expnew = expold + expchange; 
				h.setExp(expnew);
				System.out.println("You have gained " + expchange + " points of experience.");
				System.out.println("Your current exp is now at: " + expnew);
				Item item = new Item();
				System.out.println("The enemy drop an item:\n" + item.getItemStats());
				String itemInfo = item.getItemName();
				h.addItemToInv(itemInfo);
				//h.getItemInventory();
			}
		}
		if (h.getHealth() <= 0)
		{
			System.out.println("You are dead.");
			int deadexp = h.getExp();
			deadexp = deadexp - 20;
			h.setExp(deadexp);
		}
		String gs2 = h.getName() + ".ser";
		ObjectOutputStream oos2;
		try
		{
			oos2 = new ObjectOutputStream (new FileOutputStream(gs2));
			oos2.writeObject(h);
			oos2.flush();
			oos2.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		//Explore e1 = new Explore(h);
	}
	
	public static void pauseProg()
	{
		System.out.println("Press enter to continue...");
		Scanner keyboard = new Scanner(System.in);
		keyboard.nextLine();
		lb();
	}
	public static void lb()
	{
		System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}
	
	public static boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}